//---------------------------------------------------------------------------
#include <vcl.h>
#include "TUniverse.cpp"
#pragma hdrstop

#include "TTimeBox.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TTimeBox *TimeBox;

extern TUniverse *Universe;
extern double TimeScale;
extern double TimeStep;
double SCALE, STEP;
double TDigits = 12;

//---------------------------------------------------------------------------
void EditExit(TEdit *Edit, double *VAR, bool MoreThanZero)
{
	if (!Edit->Modified) return;
    else Edit->Modified = false;
	double Var = 0;
    //	     :
	if (!sscanf(Edit->Text.c_str(), "%lf", &Var) || (Edit->Text.Trim()).Length()==0) {
        Edit->Text = Float2String(*VAR,TDigits);
        return;
    }
    if (MoreThanZero && Var <= 0) {
        Edit->Text = Float2String(*VAR,TDigits);
        return;
    }
	//	  :
    *VAR = Var;
    Edit->Text = Float2String(Var,TDigits);
}
//---------------------------------------------------------------------------
__fastcall TTimeBox::TTimeBox(TComponent* Owner)
	: TForm(Owner)
{
	SpinEditGYears->Value = Universe->Time->GYears;
	SpinEditMYears->Value = Universe->Time->MYears;
	SpinEditKYears->Value = Universe->Time->KYears;
	SpinEditYears->Value = Universe->Time->Years;
	SpinEditDays->Value = Universe->Time->Days;
	SpinEditHours->Value = Universe->Time->Hours;
	SpinEditMinutes->Value = Universe->Time->Minutes;
	SpinEditSeconds->Value = int(Universe->Time->Seconds);
	SpinEditGYearsExit(NULL);
	SpinEditMYearsExit(NULL);
	SpinEditKYearsExit(NULL);
	SpinEditYearsExit(NULL);
	SpinEditDaysExit(NULL);
	SpinEditHoursExit(NULL);
	SpinEditMinutesExit(NULL);
	SpinEditSecondsExit(NULL);
    SCALE = TimeScale;
    STEP = TimeStep;
    EditScale->Text = Float2String(SCALE, TDigits);
    EditStep->Text = Float2String(STEP, TDigits);
    SBtnTurn->Down = (!Universe->Time->TimeDirection);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	Release();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditGYearsExit(TObject *Sender)
{
    if (SpinEditGYears->Value < 0)   SpinEditGYears->Value = 0;
    if (SpinEditGYears->Value > 999) SpinEditGYears->Value = 999;
    int Zeros = 3 - SpinEditGYears->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditGYears->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditGYears->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMYearsExit(TObject *Sender)
{
    int Zeros = 3 - SpinEditMYears->Text.Length();
	SpinEditMYears->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditMYears->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditKYearsExit(TObject *Sender)
{
    int Zeros = 3 - SpinEditKYears->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditKYears->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditKYears->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditYearsExit(TObject *Sender)
{
    int Zeros = 3 - SpinEditYears->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditYears->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditYears->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditDaysExit(TObject *Sender)
{
    int Zeros = 3 - SpinEditDays->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditDays->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditDays->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditHoursExit(TObject *Sender)
{
    int Zeros = 2 - SpinEditHours->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditHours->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditHours->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMinutesExit(TObject *Sender)
{
    int Zeros = 2 - SpinEditMinutes->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditMinutes->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditMinutes->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditSecondsExit(TObject *Sender)
{
    int Zeros = 2 - SpinEditSeconds->Text.Length();
    Zeros = (Zeros>0) ? Zeros : 0;
	SpinEditSeconds->Text = AnsiString::StringOfChar('0',Zeros) + SpinEditSeconds->Text;
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditGYearsBottomClick(TObject *Sender)
{
	SpinEditGYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditGYearsTopClick(TObject *Sender)
{
	SpinEditGYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMYearsBottomClick(TObject *Sender)
{
	SpinEditMYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMYearsTopClick(TObject *Sender)
{
	SpinEditMYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditKYearsBottomClick(TObject *Sender)
{
	SpinEditKYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditKYearsTopClick(TObject *Sender)
{
	SpinEditKYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditYearsBottomClick(TObject *Sender)
{
	SpinEditYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditYearsTopClick(TObject *Sender)
{
	SpinEditYearsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditDaysBottomClick(TObject *Sender)
{
	SpinEditDaysExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditDaysTopClick(TObject *Sender)
{
	SpinEditDaysExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditHoursBottomClick(TObject *Sender)
{
	SpinEditHoursExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditHoursTopClick(TObject *Sender)
{
	SpinEditHoursExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMinutesBottomClick(TObject *Sender)
{
	SpinEditMinutesExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMinutesTopClick(TObject *Sender)
{
	SpinEditMinutesExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditSecondsBottomClick(TObject *Sender)
{
	SpinEditSecondsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditSecondsTopClick(TObject *Sender)
{
	SpinEditSecondsExit(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditGYearsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditMYears->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMYearsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditKYears->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditKYearsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditYears->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditYearsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditDays->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditDaysKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditHours->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditHoursKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditMinutes->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditMinutesKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditSeconds->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SpinEditSecondsKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
	if (Key == VK_RETURN) EditScale->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::EditScaleExit(TObject *Sender)
{
	EditExit(EditScale, &SCALE, true);
    if (SCALE > 3.1536E+19) {
    	SCALE = 3.1536E+19;
	    EditScale->Text = Float2String(SCALE, TDigits);
    }
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::EditScaleKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditStep->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::EditStepExit(TObject *Sender)
{
	EditExit(EditStep, &STEP, true);
    if (STEP > 3.1536E+19) {
    	STEP = 3.1536E+19;
	    EditStep->Text = Float2String(STEP, TDigits);
    }
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::EditStepKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) BtnOK->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::SBtnTurnClick(TObject *Sender)
{
	for (int i=0; i<Universe->Count; i++) {
    	Universe->Planets[i]->Vx = -Universe->Planets[i]->Vx;
    	Universe->Planets[i]->Vy = -Universe->Planets[i]->Vy;
    	Universe->Planets[i]->Vz = -Universe->Planets[i]->Vz;
    	Universe->Planets[i]->NextVx = -Universe->Planets[i]->NextVx;
    	Universe->Planets[i]->NextVy = -Universe->Planets[i]->NextVy;
    	Universe->Planets[i]->NextVz = -Universe->Planets[i]->NextVz;
    }
    Universe->Draw();
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::BtnCancelClick(TObject *Sender)
{
	Close();	
}
//---------------------------------------------------------------------------
void __fastcall TTimeBox::BtnOKClick(TObject *Sender)
{
	Universe->Time->GYears = SpinEditGYears->Value;
	Universe->Time->MYears = SpinEditMYears->Value;
	Universe->Time->KYears = SpinEditKYears->Value;
	Universe->Time->Years = SpinEditYears->Value;
	Universe->Time->Days = SpinEditDays->Value;
	Universe->Time->Hours = SpinEditHours->Value;
	Universe->Time->Minutes = SpinEditMinutes->Value;
	Universe->Time->Seconds = SpinEditSeconds->Value;
    TimeScale = SCALE;
    TimeStep = STEP;
    Universe->Time->TimeDirection = !SBtnTurn->Down;
    Close();
}
//---------------------------------------------------------------------------

